(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/isa_toolkit/chooser2.sml,v $
 
   SimpleChooser -- an generic chooser application
   
   $Date: 1997/09/11 15:40:00 $
   $Revision: 1.2 $
   Author: cxl (Last modification by $Author: cxl $)
 
   (C) 1997, Bremen Institute for Safe Systems (BISS), Universitaet Bremen
 
  ************************************************************************** *)
 



functor SimpleChooser
    (type item
     val  name      : item-> string
     (* val  recursive : item-> (unit-> item list) TkTypes.option *)
     structure CB   : CLIPBOARD_W
     
     (* configuration parameters *)
     structure UW   : UTILWIN_CONFIG
     val selWidth   : int
     val selHeight  : int

    ) : sig
	    (* The argument list is ridiculously long, but that's modules are
	     * not first class objects. Don't blame me, blame Robin and
	     * his croonies. 
	     *)
	    val select : TkTypes.WinId TkTypes.option* (* leader window *) 
		         string* string*  (* window title, label o/t chooser *)
			 (item-> CB.obj TkTypes.option)* 
			                  (* conversion into clipboard obj. *)
			 (item-> unit)*   (* continuation when item is selected
					   * by double-click *)
		         item list        (* list of all items *)
			 -> unit
	(* val  filters   : (string* ((string* item)-> bool)) list   *)
	end =


struct     

    open TkTypes SmlTk Lib.List

    fun chooseListBox(win, sel_item, item_to_obj, cc) =
	let	
	    val lwid = newWidgetId()
	    val selected = ref 0
	    fun selItem  ev = 
		let val Mark(n, _)= readCursor lwid
		in selected := n
		end
	    fun putItem ev =
		case (item_to_obj(sel_item(!selected))) of
		    SOME obj=> (CB.put obj ev (fn _ => ()))
		                                    (* closeWindow win))*)
		  | NONE    => ()
		 handle Subscript=> ()		
	    fun cont ev =
		cc (sel_item(!selected)) handle Subscript=> ()	    
	in Listbox(lwid, RightScb, 
		   [Fill X, Expand true, Side Top],
		   [Relief Raised, Width selWidth, Height selHeight,
		    Font (Normalfont [])],
		   [Bind("<Button-1>", selItem),
		    Bind("<ButtonRelease-1>", putItem),
		    Bind("<Double-Button-1>", cont)
		   ])
	end

    fun quitButton win =
	Frame(newWidgetId(),
	      [Button(newWidgetId(), [Side Left, Expand true, Fill X], 
		      [Command (fn()=> closeWindow win), 
		       Text "Close", Font UW.buttonFont], [])
	      ], [Side Bottom, Expand true], [], [])
			

    fun Title t =
	Frame(newWidgetId(),
	      [Label(newWidgetId(), [Side Left],
		     [Text t, Font (Normalfont [Bold])], [])],
	      [Side Top, Fill X, Expand true], [], [])

    fun winConf(SOME win, t)= [WinTransient (SOME win), WinGroup win, WinTitle t]
      | winConf(NONE, t)    = [WinTransient NONE, WinTitle t]

    
    fun select(win, wintitle, title, item_to_obj, cc, items)=
	let val nuw= newWinId()
	    fun sel_item n= nth(items, n)
	    fun cont item= (closeWindow nuw; cc item)
	    val lbox= chooseListBox(nuw, sel_item, item_to_obj, cc)
	    fun fillListBox () = 
		let val lbid= selWidgetId(lbox)
		in  (clearText lbid;
		     app (fn it=> insertTextEnd lbid (name it)) items)
		end		    
	in  openWindow(nuw, winConf(win, wintitle), 
		       [Title title, lbox, quitButton nuw],
		       fillListBox)

	end

end
	

