(************************************************************)
(* Project    : Encoding Z in Isabelle                      *)
(* Author     : Steffen Helke,                              *)
(*              Thomas Neustupny                            *)
(*              Thomas Santen                               *)
(*      This theory     : Encoding Classical Steamboiler    *)
(*                       Example & some operations          *)
(* $Id: SteamDat.thy,v 1.1.2.1 1998/09/18 15:19:39 kol Exp $ *)
(************************************************************)

(************************************************************************)
(* Es ist nicht die vollstaendige Spezifikation, stellt aber alle fuer  *)
(* die Repraesentation der Schema: STEAM_BOILER_WAITING und             *) 
(* STEAM_REPAIRED erforderlichen Definitionen zur Verfuegung.           *)
(************************************************************************)

SteamDat = ZMathTool +


datatype ValveState_type   = open_valve | closed_valve 
datatype PhysModes_type      = waiting | adjusting | ready | running | stopped
datatype Alarm_type         = ON | OFF
datatype SensorStates_type  = working_sensor | broken_sensor
datatype PumpStates_type    = closed_pump |opening_pump |open_pump | broken_pump
datatype MonitorStates_type = flow_monitor | noflow_monitor | broken_monitor 


    
arities
  SensorStates_type, PhysModes_type, Alarm_type,
  ValveState_type, PumpStates_type, MonitorStates_type ::term

consts
SensorStates       :: "SensorStates_type set"
PhysModes          :: "PhysModes_type set"
Alarm              :: "Alarm_type set"
ValveState         :: "ValveState_type set"
PumpStates         :: "PumpStates_type set"
MonitorStates      :: "MonitorStates_type set"
  
"C"                :: int                ("C")
"W"                :: int                ("W")
"M1"               :: int                ("M1")
"M2"               :: int                ("M2")
"P"                :: int                ("P")
"NP"               :: int                ("NP")
"N1"               :: int                ("N1")
"N2"               :: int                ("N2")






(*rules Global_Axiom  "(($# 0) < C) &   
                  (NP = zsuc (zsuc (zsuc (zsuc ($# 0))))) &
                  (($# 0) < N1) &   
                  (N1 < N2) & 
                  (N2 < C) &   
                  (($# 0) < M1) & 
                  (M1 < N1) & 
                  (N2 < M2) &   
                  (M2 < C)" 

 *) 
defs
SensorStates_def       "SensorStates   == {a::SensorStates_type.True}"
PhysModes_def          "PhysModes      == {a::PhysModes_type.True}"
Alarm_def              "Alarm          == {a::Alarm_type.True}"
ValveState_def         "ValveState     == {a::ValveState_type.True}"
PumpStates_def         "PumpStates     == {a::PumpStates_type.True}"
MonitorStates_def      "MonitorStates  == {a::MonitorStates_type.True}"

(*get_pst_def "get_pst == (%(pst,pa1,pa2,mst).(pst))"
get_pa1_def "get_pa1 == (%(pst,pa1,pa2,mst).(pa1))"
get_pa2_def "get_pa2 == (%(pst,pa1,pa2,mst).(pa2))"
get_mst_def "get_mst == (%(pst,pa1,pa2,mst).(mst))" *)

  
end
