(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/isa_win/Attic/winz_root.sml,v $
    
   WinZ root file.   

   This file creates a stand-alone (i.e. w/o TAS) WinZ.

   Assumes HOLZ and sml_tk have already been loaded.

   $Date: 1998/09/18 15:19:19 $
   $Revision: 1.1.2.2 $
   Author: kol/cxl (Last modification by $Author: kol $)

   (C) 1996-98, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)


val isawindir= pwd();


(* ************************************************************************* *)
(* Load ida.                                                                 *)
(* ************************************************************************* *)

cd "../../isa/isa_toolkit/ida";

use "root_z.sml";
SGML.attach_ext_syntax1 BB.zthy [] [];
(* SGML.attach_ext_syntax1 Steam.zthy [] []; *)
SGML.attach_ext_syntax String.thy [] [];

(* ************************************************************************* *)
(*******                       load isa_toolkit                       ********)
(* ************************************************************************* *)

cd "/home/kol/uniform/isa_gui/isa_toolkit";

use "root.sml";

(* ************************************************************************* *)
(* load plenty of examples                                                   *)
(* ************************************************************************* *)

(* cd isawindir;
   cd "../../isa_lang/Z/examples"; 
   use "BB.sml"; *)

cd isawindir;
cd "examples";
use "winz_root.sml";


(* ************************************************************************* *)
(* load IsaWin                                                               *)
(* ************************************************************************* *)

(* load isa_toolkit *)

cd isawindir;
cd "../isa_toolkit";
use "root.sml";


(* This is what was main.sml: 
cd isawindir;
cd "Zwin";

use "main.sml"; is necessary because of types *)

cd isawindir; 

use "config.sig";

(* --- Z/Thy package  ---------------------- *)
structure Thy =
    struct
	open Basic_zproof

	type theory = ztheory
	type proof  = zproof
       
	val goalw = zgoalw
	val pop_proof     = pop_zproof
	val push_proof    = push_zproof
	val restore_proof = restore_zproof
	val save_proof    = save_zproof

	fun thyToThy th   = Zthy {thy=th, zenv=ZEnv.mt_zenv}
    end;

use "sel_tactics.sml";
use "types.sml";  
use "induct.sml";
use "zwidgets.sml"; (* w/ special z widgets *)
use "zarea.sml";
use "appl.sml";   
use "isawin.sml"; 

use "config.sml";


(*
 * Instantiante IsaWin as WinZ (this used to be isa_z.sml) 
 *)

(*val all_axioms = map snd (zaxioms_of BB.zthy) *)
 val all_ax = map bind_zthm (zaxioms_of BB.zthy);
structure IsaZ = 
    IsaWin(open IsaConfNormal
    	   open IsaWinTypes

	   val initConf = 
	       {thms =   [(subsetUnion, introThm, "subsetUnion")],
	       clasets=  [(HOL_cs, "HOL_cs")],
	       simpsets= [(HOL_ss, "HOL_ss"), (Z2HOL_ss, "Z2HOL_ss"), 
	                   (zmath_ss,"zmath_ss")],
	       theories= [( BB.zthy, "BB"), (Steam.zthy, "Steam")],
	       texts=    [("pre state of BBook defined",
			   "BBook")],
	       goals= [(BB.zthy,[],"%Delta BirthdayBook", "DeltaBirthday"),
	               (BB.zthy, [],"(+.. birthday:(Name -|-> Date);  known : Pow Name |--- known = dom(birthday) ---) = ?X", "Birthday"),
	               (BB.zthy,[],"AddBirthday --> (+.. %Delta BirthdayBook |--- (known ~= known') ---)", "KnownDiff")],
	       substs=  [],
	       eta_contract = true}
	   );

IsaWinTypes.debugon();
SmlTk.initSmlTk();

open IsaZ;


