(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/tas/root.sml,v $
 
   Rootfile for TAS.

   Assumes sml_tk is already loaded. 

   This file sets up TAS, the generic Transformation Application System. 
   It will build a functor can then be instantiated. 

   TAS instantiations live in tas_<name>.sml, like 
   tas_hol.sml
   tas_bm.sml
   tas_csp.sml.
  
   $Date: 1997/09/12 12:29:20 $
   $Revision: 1.27 $
   Author: cxl (Last modification by $Author: kol $)

   (C) 1997, Bremen Institute for Safe Systems, Universitaet Bremen

  ************************************************************************** *)


val tasdir= pwd();

(* Load isa_gui/isa_toolkit *)
cd "../isa_toolkit";
use "root.sml";
cd tasdir;

(* Load IsaWin *)
cd "../isa_win";
use "main.sml";
cd tasdir;


(* Load TAS itself *)
use "config.sig";
use "trafos.sml";
use "widgets.sml";
use "appl.sml";
use "tas.sig";
use "tas.sml";
use "api.sml";

writeln "\n\n\n\
\TAS is now setup. To instantiate TAS, load one of the following files:\n\
\- \"tas_hol.sml\" for TAS with Higher-Order Logic.\n\
\- \"tas_bm.sml\"  for TAS with the Bird-Meertens calculus.\n\
\- \"tas_csp.sml\" for TAS with CSP.\n\
\- \"tas_z.sml\" for TAS with Z.\n\n"
