(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/tas/trafos/std_thy.sml,v $
    
   Isabelle standard theories (theory reader, goal package) as a plug-in
   structure for TAS.
   
   $Date: 1997/09/12 17:18:51 $
   $Revision: 1.4 $
   Author: cxl (Last modification by $Author: cxl $)
 
   (C) 1997, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)


structure StdThy: THEORY = 
    struct

	type theory= Theory.theory

	fun use thynm =  theory_of thynm
	                 handle ERROR =>
			 (use_thy thynm; 
			  let val thy= theory_of thynm
			  in  SGML.attach_ext_syntax thy [] []; thy
			  end)


	fun goal(s, t)=  Goals.goal s t

	val eq            = eq_thy
	val parents_of    = parents_of
	val theory_of_thm = theory_of_thm 

	val theoryfile_suffix = "thy"

	fun name_of th = !(hd(stamps_of_thy th))

	type proofstate = proof
	val  restore    = ignore o restore_proof
	val  save       = save_proof
    end
