(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1996/09/25 11:06:05 $
  $Revision: 1.3 $
   Purpose of this file: Functions related to Canvas Items in Widget Tree

   *********************************************************************** *)

signature C_ITEM_TREE =
    sig
	open BasicTypes

	exception CITEM_TREE of string

	val get : WidId -> CItemId -> CItem
	val upd : WidId -> CItemId -> CItem -> unit

	(*           inWid    toAdd                   *)
	val add    : WidId -> CItem            -> unit
	(*           inWid    toAdd    after          *)
(*	val insert : WidId -> CItem -> CItemId -> unit                      *)
	(*           inWid    toDel                   *)
	val delete : WidId -> CItemId          -> unit


	val getConfigure  : WidId -> CItemId -> Configure list
(*	val setConfigure  : WidId -> CItemId -> Configure list -> unit      *)
	val addConfigure  : WidId -> CItemId -> Configure list -> unit

	val getBinding    : WidId -> CItemId -> Binding list
(*	val setBinding    : WidId -> CItemId -> Binding list -> unit        *)
	val addBinding    : WidId -> CItemId -> Binding list -> unit

(*	val getTags : WidId -> CItemId -> CItemId list                      *)


	val getCoords  : WidId -> CItemId -> Coord list 
	val setCoords  : WidId -> CItemId -> Coord list -> unit

	val getWidth   : WidId -> CItemId -> int
	val getHeight  : WidId -> CItemId -> int

	val getIconWidth  : IconKind -> int
	val getIconHeight : IconKind -> int

	(*                             distance      *)
	val move : WidId -> CItemId -> Coord -> unit

    end
