(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1997/03/13 15:56:39 $
  $Revision: 1.2 $
   Purpose of this file: Coordinate Module

   *********************************************************************** *)

signature COORD =
    sig
	open BasicTypes

	exception COORD of string

	val show : Coord list -> string
	val read : string -> Coord list

	val add : Coord -> Coord -> Coord
	val sub : Coord-> Coord -> Coord
	val smult : Coord-> int-> Coord

        type Rect

	val inside   : Coord-> Rect-> bool
	val moveRect : Rect-> Coord-> Rect
        val showRect : Rect-> string

    end
