(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1996/09/25 11:06:17 $
  $Revision: 1.2 $
   Purpose of this file: Mark Module

   *********************************************************************** *)

structure Mark : MARK = 
struct

infix 1 ELEM;
infix 1 /=;
nonfix prefix;

local open BasicTypes in


exception MARK of string


fun show (Mark(n,m))     = (makestring n) ^"."^(makestring m)
   |show (MarkToEnd n)   = (makestring n) ^".end"
   |show MarkEnd         = "end";


fun showL ml = BasicUtil.concatWith " " (map (fn (m1,m2) => (show m1)^" "^(show m2)) ml)



fun read m =
    let
	val (x,y)   = BasicUtil.break SysDep.isDot (explode m)
    in
	if ( ((length y) = 0) andalso ( (implode x) = "end") ) then
	    MarkEnd
	else if ( (not ((length x) = 0)) andalso ( (implode (tl y)) = "end") ) then
	    MarkToEnd (SysDep.numval x)
	else
	    Mark(SysDep.numval x,SysDep.numval (tl y))
    end

fun readL ml =
    let 
	val mls = BasicUtil.words ml

	fun dezip []        = []
	  | dezip (x::y::l) = (x,y)::(dezip l)
	  | dezip _         = raise MARK "MARK.readL: odd number of marks"

    in
	dezip (map read mls)
    end


(*
fun read str =
    let
	val _   = Debug.print("Coord.read: \""^str^"\"")
	val cos = BasicUtil.words str
	fun dezip []        = []
	  | dezip (x::y::l) = 
	    let
		val notIsDot = (op not) o (SysDep.isDot)
		val x' = SysDep.numval(BasicUtil.takeWhile notIsDot (explode(x)) )
		val y' = SysDep.numval(BasicUtil.takeWhile notIsDot (explode(y)) )
	    in
		(x',y')::(dezip l)
	    end
	  | dezip _         = raise COORD "Coord.read: odd number of coordinates"
    in
	(dezip cos) handle Overflow => raise COORD "Coord.read: number conversion error"
    end
*)

end 

end
