(* ***************************************************************************
 
   $Source: /home/uniform/rep/sml/sml_tk/njml.sig,v $

   System dependent functions (ie. depending in the SML used)

   This signature has one implementation each for the different SMLs used. 
   Currently, there are
   - njml.sml (loaded from root.sml) for NJSML093
   - njml1.sml (loaded from sources.cm) for NJSML109

   $Date: 1997/11/14 10:42:52 $
   $Revision: 1.6 $
   Author: stefan (Last modification by $Author: cxl $)

   (C) 1996, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)

signature SYS_DEP =
    sig	
        type 'a option (* datatype 'a option = JUST of 'a | NONE *)        
         
	val execute: string * string list -> instream * outstream
	val exec   : string * string list -> bool
	val cd     : string -> unit
	val ls     : string -> string list
	val pwd    : unit -> string
	val isDir  : string -> bool
	val getEnv : string -> string option

	val isDirRdAndWr  : string -> bool
	val isFileRd      : string -> bool
	val isFileRdAndEx : string -> bool

	val openFile : ( string -> exn) -> string -> instream

	val inc    : int ref -> unit

        val nth    : 'a list * int -> 'a

	val isPrint    : char -> bool
	val isUpper    : char -> bool
	val isLower    : char -> bool
	val isAlpha    : char -> bool
	val isDigit    : char -> bool
	val isAlphanum : char -> bool
	val isSpace    : char -> bool

	val isDot        : char -> bool
	val isComma      : char -> bool
	val isLinefeed   : char -> bool
	val isOpenParen  : char -> bool
	val isCloseParen : char -> bool
	    
	val numval : char list -> int

	val adaptString : string -> string

	val min : int -> int -> int
	val max : int -> int -> int

	val xSmlTk : string -> string -> unit
	val setPrintDepth : int -> unit
    end;
