(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1996/06/19 11:53:56 $
  $Revision: 1.1 $
   Purpose of this file: Functions related to Path-Management

   *********************************************************************** *)

signature PATHS =
    sig
	open BasicTypes

	(* PathAss = (WidId * (WinId * WidPath )) *)
	(*                    {    IntPath     }  *)

	(* Selektoren *)
	val fstWidPath  : WidPath -> (WidId * WidPath)
	val lastWidPath : WidPath -> (WidPath * WidId)

	(* Konstruktoren und Destruktoren *)
	val addWidget        : WidId -> WinId -> WidPath -> PathAss list -> PathAss list

	val deleteWidget     : WidId   -> PathAss list -> PathAss list
	val deleteWidgetPath : IntPath -> PathAss list -> PathAss list

	val deleteWindow : WinId -> PathAss list -> PathAss list

	val newWidgetId : unit -> WidId


	val getTclPathGUI            : IntPath -> TclPath
	val getIntPathGUI            : WidId -> IntPath
	val getWidPathGUI            : WidId -> WidPath
	val getIntPathFromTclPathGUI : TclPath -> (WinId * WidId)

	val occursWidgetGUI : WidId -> bool
	val occursWindowGUI : WinId -> bool

    end
